static const char *RcsId = "$Header:  $";
//+=============================================================================
//
// file :         PseudoAxes.cpp
//
// description :  C++ source for the PseudoAxes and its commands. 
//                The class is derived from Device. It represents the
//                CORBA servant object which will be accessed from the
//                network. All commands which can be executed on the
//                PseudoAxes are implemented in this file.
//
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//-=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================



//===================================================================
//
//	The following table gives the correspondence
//	between commands and method name.
//
//  Command name|  Method name
//	----------------------------------------
//  State     |  dev_state()
//  Status    |  dev_status()
//  AxisInit  |  axis_init()
//  Apply     |  apply()
//
//===================================================================


#include <tango.h>
#include <PseudoAxes.h>
#include <PseudoAxesClass.h>

#include "TangoHKLAdapterFactory.h"

namespace PseudoAxes_ns
{

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::PseudoAxes(string &s)
// 
// description : 	constructor for simulated PseudoAxes
//
// in : - cl : Pointer to the DeviceClass object
//      - s : Device name 
//
//-----------------------------------------------------------------------------
PseudoAxes::PseudoAxes(Tango::DeviceClass *cl,string &s)
:Tango::Device_4Impl(cl,s.c_str())
{
	init_device();
}

PseudoAxes::PseudoAxes(Tango::DeviceClass *cl,const char *s)
:Tango::Device_4Impl(cl,s)
{
	init_device();
}

PseudoAxes::PseudoAxes(Tango::DeviceClass *cl,const char *s,const char *d)
:Tango::Device_4Impl(cl,s,d)
{
	init_device();
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::delete_device()
// 
// description : 	will be called at device destruction or at init command.
//
//-----------------------------------------------------------------------------
void PseudoAxes::delete_device()
{
	//	Delete device's allocated object

	if(_adapter){
		_adapter->save();
		_adapter->remove_dynamic_attributes();
		_adapter = NULL;
	}
	_hklAdapter = NULL;
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::init_device()
// 
// description : 	will be called at device initialization.
//
//-----------------------------------------------------------------------------
void PseudoAxes::init_device()
{
	INFO_STREAM << "PseudoAxes::PseudoAxes() create device " << device_name << endl;

	// Initialise variables to default values
	//--------------------------------------------
	get_device_property();

	_adapter = NULL;
	_hklAdapter = NULL;

	config.state = Tango::FAULT;
	config.status = "Not yet initialized";
	config.initialized = false;
	config.mode = NULL;

	// we can get the Diffractometer device adapter in the init as this one start all PseudoAxes
	if(!_hklAdapter)
		_hklAdapter = Diffractometer_ns::TangoHKLAdapterFactory::instance()->get_diffractometer_adapter(diffractometerProxy);

	if(_hklAdapter && !_adapter){
		_adapter = _hklAdapter->pseudo_axes_adapter_get_by_name(engineName);
		if(_adapter){
			_adapter->set_device(this);
			_adapter->add_dynamic_attributes();
			_adapter->load();
		}
	}
}


//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::get_device_property()
// 
// description : 	Read the device properties from database.
//
//-----------------------------------------------------------------------------
void PseudoAxes::get_device_property()
{
	//	Initialize your default values here (if not done with  POGO).
	//------------------------------------------------------------------

	//	Read device properties from database.(Automatic code generation)
	//------------------------------------------------------------------
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("DiffractometerProxy"));
	dev_prop.push_back(Tango::DbDatum("EngineName"));

	//	Call database and extract values
	//--------------------------------------------
	if (Tango::Util::instance()->_UseDb==true)
		get_db_device()->get_property(dev_prop);
	Tango::DbDatum	def_prop, cl_prop;
	PseudoAxesClass	*ds_class =
		(static_cast<PseudoAxesClass *>(get_device_class()));
	int	i = -1;

	//	Try to initialize DiffractometerProxy from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  diffractometerProxy;
	else {
		//	Try to initialize DiffractometerProxy from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  diffractometerProxy;
	}
	//	And try to extract DiffractometerProxy value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  diffractometerProxy;

	//	Try to initialize EngineName from class property
	cl_prop = ds_class->get_class_property(dev_prop[++i].name);
	if (cl_prop.is_empty()==false)	cl_prop  >>  engineName;
	else {
		//	Try to initialize EngineName from default device value
		def_prop = ds_class->get_default_device_property(dev_prop[i].name);
		if (def_prop.is_empty()==false)	def_prop  >>  engineName;
	}
	//	And try to extract EngineName value from database
	if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  engineName;



	//	End of Automatic code generation
	//------------------------------------------------------------------

}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::always_executed_hook()
// 
// description : 	method always executed before any command is executed
//
//-----------------------------------------------------------------------------
void PseudoAxes::always_executed_hook()
{
	if(!_hklAdapter)
		_hklAdapter = Diffractometer_ns::TangoHKLAdapterFactory::instance()->get_diffractometer_adapter(diffractometerProxy);

	if(_hklAdapter && !_adapter)
		_adapter = _hklAdapter->pseudo_axes_adapter_get_by_name(engineName);	
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_attr_hardware
// 
// description : 	Hardware acquisition for attributes.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_attr_hardware(vector<long> &attr_list)
{
	DEBUG_STREAM << "PseudoAxes::read_attr_hardware(vector<long> &attr_list) entering... "<< endl;
	//	Add your own code here
	if(_adapter)
		config = _adapter->get_config();
}
//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_initialized
// 
// description : 	Extract real attribute values for initialized acquisition result.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_initialized(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::read_initialized(Tango::Attribute &attr) entering... "<< endl;
	if(_adapter)
		attr.set_value(&config.initialized);
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::write_initialized
// 
// description : 	Write initialized attribute values to hardware.
//
//-----------------------------------------------------------------------------
void PseudoAxes::write_initialized(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::write_initialized(Tango::WAttribute &attr) entering... "<< endl;

	if(_adapter){
		Tango::DevBoolean initialized;
		attr.get_write_value(initialized);
		_adapter->set_initialized(initialized);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_parameters
// 
// description : 	Extract real attribute values for parameters acquisition result.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_parameters(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::read_parameters(Tango::Attribute &attr) entering... "<< endl;

	if(_adapter){
		Matrix<double> const & img = config.parameters;
		attr.set_value(img.data, img.xdim);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::write_parameters
// 
// description : 	Write parameters attribute values to hardware.
//
//-----------------------------------------------------------------------------
void PseudoAxes::write_parameters(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::write_parameters(Tango::WAttribute &attr) entering... "<< endl;

	if(_adapter){
		const Tango::DevDouble *values;
		attr.get_write_value(values);
		Matrix<double> img;
		img.attach_to_const_buffer(values,
					   attr.get_w_dim_x(), attr.get_w_dim_y());
		
		_adapter->set_parameters(img);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_pseudoAxisNames
// 
// description : 	Extract real attribute values for pseudoAxisNames acquisition result.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_pseudoAxisNames(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::read_pseudoAxisNames(Tango::Attribute &attr) entering... "<< endl;
	if(_adapter){
		Matrix<char *> const & img = config.pseudo_axes_names;
		attr.set_value(img.data, img.xdim);
	}
}


//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_mode
// 
// description : 	Extract real attribute values for mode acquisition result.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_mode(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::read_mode(Tango::Attribute &attr) entering... "<< endl;
	if(_adapter)
		attr.set_value(&config.mode);
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::write_mode
// 
// description : 	Write mode attribute values to hardware.
//
//-----------------------------------------------------------------------------
void PseudoAxes::write_mode(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::write_mode(Tango::WAttribute &attr) entering... "<< endl;
	attr.get_write_value(attr_mode_write);
	if(_adapter)
		_adapter->set_mode(attr_mode_write);
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_modeNames
// 
// description : 	Extract real attribute values for modeNames acquisition result.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_modeNames(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::read_modeNames(Tango::Attribute &attr) entering... "<< endl;
	if(_adapter){
		Matrix<char *> const & img = config.mode_names;
		attr.set_value(img.data, img.xdim);
	}
}

//+----------------------------------------------------------------------------
//
// method : 		PseudoAxes::read_parametersNames
// 
// description : 	Extract real attribute values for parametersNames acquisition result.
//
//-----------------------------------------------------------------------------
void PseudoAxes::read_parametersNames(Tango::Attribute &attr)
{
	DEBUG_STREAM << "PseudoAxes::read_parametersNames(Tango::Attribute &attr) entering... "<< endl;
	if(_adapter){
		Matrix<char *> const & img = config.parameters_names;
		attr.set_value(img.data, img.xdim);
	}
}

//+------------------------------------------------------------------
/**
 *	method:	PseudoAxes::axis_init
 *
 *	description:	method to execute "AxisInit"
 *	Initialize the pseudoAxes (exemple the psi pseudo axis)
 *
 *
 */
//+------------------------------------------------------------------
void PseudoAxes::axis_init()
{
	DEBUG_STREAM << "PseudoAxes::axis_init(): entering... !" << endl;

	//	Add your own code to control device here
	if(_adapter)
		_adapter->init();
}


//+------------------------------------------------------------------
/**
 *	method:	PseudoAxes::dev_state
 *
 *	description:	method to execute "State"
 *	This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.
 *
 * @return	State Code
 *
 */
//+------------------------------------------------------------------
Tango::DevState PseudoAxes::dev_state()
{
	Tango::DevState	argout = DeviceImpl::dev_state();
	DEBUG_STREAM << "PseudoAxes::dev_state(): entering... !" << endl;

	//	Add your own code to control device here

	if(_adapter)
		this->set_state(config.state);

	return this->device_state;
}

//+------------------------------------------------------------------
/**
 *	method:	PseudoAxes::dev_status
 *
 *	description:	method to execute "Status"
 *	This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
 *
 * @return	Status description
 *
 */
//+------------------------------------------------------------------
Tango::ConstDevString PseudoAxes::dev_status()
{
	Tango::ConstDevString	argout = DeviceImpl::dev_status();
	DEBUG_STREAM << "PseudoAxes::dev_status(): entering... !" << endl;

	//	Add your own code to control device here

	if(_adapter)
		this->set_status(config.status);
	
	return this->device_status.c_str();
}



//+------------------------------------------------------------------
/**
 *	method:	PseudoAxes::apply
 *
 *	description:	method to execute "Apply"
 *	Apply the values of the pseudo axes and write them on the diffractometer device.
 *
 *
 */
//+------------------------------------------------------------------
void PseudoAxes::apply()
{
	DEBUG_STREAM << "PseudoAxes::apply(): entering... !" << endl;

	//	Add your own code to control device here
	if(_adapter)
		_adapter->apply();
}

}	//	namespace
